package eu.eudat.logic.managers;

import eu.eudat.data.entities.DataRepository;
import eu.eudat.data.entities.Registry;
import eu.eudat.logic.services.ApiContext;
import eu.eudat.models.data.datarepository.DataRepositoryModel;
import eu.eudat.models.data.registries.RegistryModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class RegistryManager {

    private ApiContext apiContext;

    @Autowired
    public RegistryManager(ApiContext apiContext) {
        this.apiContext = apiContext;
    }

    public Registry create(RegistryModel registryModel) throws Exception {
        Registry registry = registryModel.toDataModel();
        return apiContext.getOperationsContext().getDatabaseRepository().getRegistryDao().createOrUpdate(registry);
    }
}
