import { NgModule } from '@angular/core';
import { CommonUiModule } from '../../common/ui/common-ui.module';
import { CardComponent } from './card/card.component';
import { DashboardComponent } from './dashboard.component';
import { DashboardRoutingModule } from './dashboard.routing';
import { DraftsComponent } from './drafts/drafts.component';
import { InfoCounterComponent } from './info-counter/info-counter.component';
import { QuickWizardCreateAdd } from './quick-wizard-create-add/quick-wizard-create-add.component';
import { RecentActivityComponent } from './recent-activity/recent-activity.component';
import { RecentEditedActivityComponent } from './recent-edited-activity/recent-edited-activity.component';
import { RecentVisitedActivityComponent } from './recent-visited-activity/recent-visited-activity.component';
import { WizardComponent } from './wizard/wizard.component';
import { DmpInfoCounterComponent } from './dmp-info-counter/dmp-info-counter.component';
import { DatasetInfoCounterComponent } from './dataset-info-counter/dataset-info-counter.component';
import { ExportMethodDialogModule } from '../../library/export-method-dialog/export-method-dialog.module';


@NgModule({
	imports: [
		CommonUiModule,
		DashboardRoutingModule,
		ExportMethodDialogModule
	],
	declarations: [
		DashboardComponent,
		RecentActivityComponent,
		CardComponent,
		QuickWizardCreateAdd,
		WizardComponent,
		InfoCounterComponent,
		RecentVisitedActivityComponent,
		RecentEditedActivityComponent,
		DraftsComponent,
		DmpInfoCounterComponent,
		DatasetInfoCounterComponent
	],
	entryComponents: [
		QuickWizardCreateAdd
	]
})
export class DashboardModule { }
