import { Component, Inject, OnInit } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material';
import { takeUntil } from 'rxjs/operators';
import { BaseComponent } from '../../../../../../core/common/base/base.component';
import { ExternalDatasetService } from '../../../../../../core/services/external-sources/dataset/external-dataset.service';
import { ExternalDatasetEditorModel } from '../../../dataset-wizard-editor.model';

@Component({
	templateUrl: 'dataset-external-dataset-dialog-editor.component.html',
	styleUrls: ['./dataset-external-dataset-dialog-editor.component.scss']
})
export class DatasetExternalDatasetDialogEditorComponent extends BaseComponent implements OnInit {
	public formGroup: FormGroup;

	constructor(
		private externalDatasetService: ExternalDatasetService,
		public dialogRef: MatDialogRef<DatasetExternalDatasetDialogEditorComponent>,
		@Inject(MAT_DIALOG_DATA) public data: any
	) { super(); }

	ngOnInit(): void {
		const externalDatasetModel = new ExternalDatasetEditorModel();
		this.formGroup = externalDatasetModel.buildForm();
	}


	send(value: any) {
		this.externalDatasetService.create(this.formGroup.value)
			.pipe(takeUntil(this._destroyed))
			.subscribe(
				(item) => this.dialogRef.close(item)
			);
	}
}
