import { NgModule } from '@angular/core';
import { CommonFormsModule } from '../../common/forms/common-forms.module';
import { CommonUiModule } from '../../common/ui/common-ui.module';
import { FormattingModule } from '../../core/formatting.module';
import { AutoCompleteModule } from '../../library/auto-complete/auto-complete.module';
import { ConfirmationDialogModule } from '../../library/confirmation-dialog/confirmation-dialog.module';
import { UrlListingModule } from '../../library/url-listing/url-listing.module';
import { DmpRoutingModule } from './dmp.routing';
import { AddResearcherComponent } from './editor/add-researcher/add-researcher.component';
import { AvailableProfilesComponent } from './editor/available-profiles/available-profiles.component';
import { DmpEditorComponent } from './editor/dmp-editor.component';
import { DmpFinalizeDialogComponent } from './editor/dmp-finalize-dialog/dmp-finalize-dialog.component';
import { DynamicDmpFieldResolverComponent } from './editor/dynamic-field-resolver/dynamic-dmp-field-resolver.component';
import { DynamicFieldGrantComponent } from './editor/dynamic-fields-grant/dynamic-field-grant/dynamic-field-grant.component';
import { DynamicFieldsGrantComponent } from './editor/dynamic-fields-grant/dynamic-fields-grant.component';
import { InvitationAcceptedComponent } from './invitation/accepted/dmp-invitation-accepted.component';
import { DmpInvitationDialogComponent } from './invitation/dmp-invitation.component';
import { DmpCriteriaComponent } from './listing/criteria/dmp-criteria.component';
import { DmpUploadDialogue } from './listing/criteria/upload-dialogue/dmp-upload-dialogue.component';
import { DmpListingComponent } from './listing/dmp-listing.component';
import { DmpListingItemComponent } from './listing/listing-item/dmp-listing-item.component';
import { DmpWizardComponent } from './wizard/dmp-wizard.component';
import { DmpWizardEditorComponent } from './wizard/editor/dmp-wizard-editor.component';
import { DmpWizardDatasetListingComponent } from './wizard/listing/dmp-wizard-dataset-listing.component';
import { ExportMethodDialogModule } from '../../library/export-method-dialog/export-method-dialog.module';
import { GeneralTabComponent } from './editor/general-tab/general-tab.component';
import { PeopleTabComponent } from './editor/people-tab/people-tab.component';
import { GrantTabComponent } from './editor/grant-tab/grant-tab.component';
import { DatasetsTabComponent } from './editor/datasets-tab/datasets-tab.component';
import { DmpOverviewModule } from './overview/dmp-overview.module';

@NgModule({
	imports: [
		CommonUiModule,
		CommonFormsModule,
		UrlListingModule,
		ConfirmationDialogModule,
		ExportMethodDialogModule,
		FormattingModule,
		AutoCompleteModule,
		DmpRoutingModule,
		DmpOverviewModule
	],
	declarations: [
		DmpListingComponent,
		DmpCriteriaComponent,
		DmpEditorComponent,
		DmpInvitationDialogComponent,
		InvitationAcceptedComponent,
		DmpWizardComponent,
		DmpWizardEditorComponent,
		DmpWizardDatasetListingComponent,
		AddResearcherComponent,
		AvailableProfilesComponent,
		DmpFinalizeDialogComponent,
		DynamicDmpFieldResolverComponent,
		DynamicFieldsGrantComponent,
		DynamicFieldGrantComponent,
		DmpUploadDialogue,
		DmpListingItemComponent,
		GeneralTabComponent,
		PeopleTabComponent,
		GrantTabComponent,
		DatasetsTabComponent
	],
	entryComponents: [
		DmpInvitationDialogComponent,
		AddResearcherComponent,
		AvailableProfilesComponent,
		DmpFinalizeDialogComponent,
		DmpUploadDialogue
	]
})
export class DmpModule { }
