import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { DmpEditorWizardComponent } from './dmp-editor/dmp-editor-wizard.component';
import { GrantEditorWizardComponent } from './grant-editor/grant-editor-wizard.component';
import { QuickWizardEditorComponent } from './quick-wizard-editor/quick-wizard-editor.component';
import { DatasetEditorWizardComponent } from './dataset-editor/dataset-editor-wizard.component';

const routes: Routes = [
	{
		path: '',
		component: QuickWizardEditorComponent,
		data: {
			breadcrumb: true
		},
	},{
		path: 'grant',
		component: GrantEditorWizardComponent,
		data: {
			breadcrumb: true
		},
	},
	{
		path: 'dmp',
		component: DmpEditorWizardComponent,
		data: {
			breadcrumb: true
		},
	},
	{
		path: 'dataset',
		component: DatasetEditorWizardComponent,
		data: {
			breadcrumb: true
		},
	}
];

@NgModule({
	imports: [RouterModule.forChild(routes)],
	exports: [RouterModule]
})
export class QuickWizardRoutingModule { }
